/**
 *
 * Created by Kyle Benk
 *
 * kjbenk@gmail.com
 *
 * 10/1/14
 */

jQuery(document).ready(function($) {

	var stub_showing = false;

	// Show firebar

	if (typeof(wps_fb_data) != "undefined" && wps_fb_data !== null) {

		// Record Impression

		var data = {
			'action': 'wps_fb_record_impression',
			'firebar_id': $('#' + wps_fb_data.prefix_dash + 'firebar-id').attr('data-firebar-id')
		};
		// We can also pass the url value separately from ajaxurl for front end AJAX implementations
		$.post(wps_fb_data.ajaxurl, data, function(response) {
			console.log(response);
		});

		var location = wps_fb_data.location.toLowerCase();
		var contanier = '.' + wps_fb_data.prefix_dash + 'container-' + location;
		var link_img = '.' + wps_fb_data.prefix_dash + 'link img';

		window.setTimeout(function() {

			if (wps_fb_data.display == 'Bar') {
		    	wpsite_firebar_show(location);
	    	} else {
			    wpsite_firebar_hide(location);
		    }

		}, 0);

		$('.' + wps_fb_data.prefix_dash + 'close').click(function(){

			if ( wps_fb_data.close_button ) {
				var data = {
					'action': 'wps_fb_set_close_cookie',
					'firebar_id': $('#' + wps_fb_data.prefix_dash + 'firebar-id').attr('data-firebar-id')
				};
				// We can also pass the url value separately from ajaxurl for front end AJAX implementations
				$.post(wps_fb_data.ajaxurl, data, function(response) {
					console.log(response);
				});
			}

			wpsite_firebar_hide(location);
		});

		$('.' + wps_fb_data.prefix_dash + 'show').click(function(){
			wpsite_firebar_show(location);
		});
	}

    // Email Signup Form

    if ($('#' + wps_fb_data.prefix_dash + 'newsletter-type').length != 0) {

	    $('#' + wps_fb_data.prefix_dash + 'newsletter').submit(function(event){

		    if ($('#' + wps_fb_data.prefix_dash + 'newsletter-type').html() == 'WordPress' ||
		    	$('#' + wps_fb_data.prefix_dash + 'newsletter-type').html() == 'aweber' ||
		    	$('#' + wps_fb_data.prefix_dash + 'newsletter-type').html() == 'MailChimp' ||
		    	$('#' + wps_fb_data.prefix_dash + 'newsletter-type').html() == 'getresponse' ||
		    	$('#' + wps_fb_data.prefix_dash + 'newsletter-type').html() == 'campaignmonitor' ||
		    	$('#' + wps_fb_data.prefix_dash + 'newsletter-type').html() == 'madmimi' ||
		    	$('#' + wps_fb_data.prefix_dash + 'newsletter-type').html() == 'infusionsoft' ||
		    	$('#' + wps_fb_data.prefix_dash + 'newsletter-type').html() == 'mymail' ||
		    	$('#' + wps_fb_data.prefix_dash + 'newsletter-type').html() == 'activecampaign') {

			    event.preventDefault();

			    $('<i style="margin-left: 10px;" class="' + wps_fb_data.prefix_dash + 'submit-spinner fa fa-spinner fa-spin"></i>').insertAfter('.' + wps_fb_data.prefix_dash + 'submit');
			    $('.' + wps_fb_data.prefix_dash + 'submit-spinner').css('color', wps_fb_data.text_color);

				var data = {
					'action': 'wps_fb_add_email',
					'firebar_id': $('#' + wps_fb_data.prefix_dash + 'firebar-id').attr('data-firebar-id'),
					'type': $('#' + wps_fb_data.prefix_dash + 'newsletter-type').html(),
					'email': $('#' + wps_fb_data.prefix_dash + 'email').val(),
					'first_name': $('#' + wps_fb_data.prefix_dash + 'first-name').val(),
					'last_name': $('#' + wps_fb_data.prefix_dash + 'last-name').val(),
				};

				jQuery.post(wps_fb_data.ajaxurl, data, function(response) {

					console.log(response);

					response = jQuery.parseJSON(response);
					if (typeof(response.conversion) != 'undefined') {
						console.log(response.conversion);
					}

					if (response.success_action == 'redirect') {

						var win = window.open(response.url, '_self');
						win.focus();

					} else {

						$('.' + wps_fb_data.prefix_dash + 'submit-spinner').remove();
						$('.' + wps_fb_data.prefix_dash + 'message').html('<i class="fa fa-' + response.status + '"></i> ' + response.message);
						$('.' + wps_fb_data.prefix_dash + 'message').css('margin-top', '10px');



						if (response.status == 'check') {
							setTimeout(function() {
								 wpsite_firebar_hide(wps_fb_data.location.toLowerCase());
								 $('.' + wps_fb_data.prefix_dash + 'message').html('');
								 $('.' + wps_fb_data.prefix_dash + 'message').css('margin-top', '0px');
							}, 3000);
						}
					}

				});

		    }
		});

    }

	 // Tweets or Recent Posts

    if ($('.' + wps_fb_data.prefix_dash + 'scroller').length != 0) {
		$('.' + wps_fb_data.prefix_dash + 'scroller').newsTicker();

		var wps_fb_scroller_width = function () {
		   $('.' + wps_fb_data.prefix_dash + 'scroller').css({"width": ($(window).width() - 50) + "px"});
		};

		$(window).resize(wps_fb_scroller_width);
		wps_fb_scroller_width();
	}

	// Add span tags to all text elements in Twitter Feed

	if ($('.' + wps_fb_data.prefix_dash + 'twitter-feed').length != 0) {
		var textnodes = wpsite_getTextNodesIn($('.' + wps_fb_data.prefix_dash + 'twitter-feed')[0]);

		for(var i=0; i < textnodes.length; i++){
		    if($(textnodes[i]).parent().is('.' + wps_fb_data.prefix_dash + 'twitter-feed')){
		        $(textnodes[i]).wrap("<span class='" + wps_fb_data.prefix_dash + "twitter-feed-text'>");
		    }
		}
	}

	if ($('.' + wps_fb_data.prefix_dash + 'scroller li').length != 0) {
		$.each($('.' + wps_fb_data.prefix_dash + 'scroller li'), function(key, value) {
			var textnodes = wpsite_getTextNodesIn($(this)[0]);

			for(var i=0; i < textnodes.length; i++){
			    if($(textnodes[i]).parent().is(this)){
			        $(textnodes[i]).wrap("<span class='" + wps_fb_data.prefix_dash + "scroller-li-text'>");
			    }
			}

		});
	}

	// Track links being clicked

	$('.' + wps_fb_data.prefix_dash + 'container').click(function(event){

		// Link was clicked

		if ($(event.target).closest('a').length){

			var data = {
				'action': 'wps_fb_record_click',
				'firebar_id': $('#' + wps_fb_data.prefix_dash + 'firebar-id').attr('data-firebar-id')
			};
			// We can also pass the url value separately from ajaxurl for front end AJAX implementations
			$.post(wps_fb_data.ajaxurl, data, function(response) {
				console.log(response);
			});

		}
	});

	/**
	 * Adds style to the firebar
	 *
	 * @access public
	 * @param mixed location
	 * @return void
	 */
	function addStyle(location) {

		if (wps_fb_data.google_fonts) {
			addGoogleFont();
		}

		// Change the background color

		var container = '.' + wps_fb_data.prefix_dash + 'container';
		var icon = '.' + wps_fb_data.prefix_dash + 'icon';
		var show = '.' + wps_fb_data.prefix_dash + 'show';
		var stub = '.' + wps_fb_data.prefix_dash + 'stub';
		var close = '.' + wps_fb_data.prefix_dash + 'close';
		var text = '.' + wps_fb_data.prefix_dash + 'text';
		var link = '.' + wps_fb_data.prefix_dash + 'link';
		var link_button = '.' + wps_fb_data.prefix_dash + 'link-button';
		var nl_button = '.' + wps_fb_data.prefix_dash + 'newsletter-button';

		var border_location = 'top';

		if (location == 'top') {
			border_location = 'bottom';
		}

		$(container).css('background-color', wps_fb_data.color);

		// Font Style

			// Small

			if (wps_fb_data.font_size == 14) {
				$('.' + wps_fb_data.prefix_dash + 'scroller li').css('height', '15px');
				$('.' + wps_fb_data.prefix_dash + 'scroller li').css('padding', '10px 0px');
				$('.' + wps_fb_data.prefix_dash + 'twitter-feed').css('height', '30px');
				$('.' + wps_fb_data.prefix_dash + 'recent-post').css('height', '30px');

				$('.' + wps_fb_data.prefix_dash + 'link-button').css('padding', '1px 5px');

				$('.' + wps_fb_data.prefix_dash + 'form input').css('padding', '1px 5px');
				$('.' + wps_fb_data.prefix_dash + 'form input').css('height', '28px');

				$(icon).css('font-size', parseInt(wps_fb_data.font_size) + 5 + 'px');
			}

			// Medium

			else if (wps_fb_data.font_size == 16) {
				$('.' + wps_fb_data.prefix_dash + 'scroller li').css('height', '20px');
				$('.' + wps_fb_data.prefix_dash + 'scroller li').css('padding', '8px 0px');
				$('.' + wps_fb_data.prefix_dash + 'twitter-feed').css('height', '34px');
				$('.' + wps_fb_data.prefix_dash + 'recent-post').css('height', '34px');

				$('.' + wps_fb_data.prefix_dash + 'link-button').css('padding', '5px 10px');

				$('.' + wps_fb_data.prefix_dash + 'form input').css('padding', '5px 10px');
				$('.' + wps_fb_data.prefix_dash + 'form input').css('height', '30px');

				$(icon).css('font-size', parseInt(wps_fb_data.font_size) + 6 + 'px');
			}

			// Large

			else if (wps_fb_data.font_size == 22) {
				$('.' + wps_fb_data.prefix_dash + 'scroller li').css('height', '25px');
				$('.' + wps_fb_data.prefix_dash + 'scroller li').css('padding', '4px 0px');
				$('.' + wps_fb_data.prefix_dash + 'twitter-feed').css('height', '38px');
				$('.' + wps_fb_data.prefix_dash + 'recent-post').css('height', '38px');

				$('.' + wps_fb_data.prefix_dash + 'link-button').css('padding', '6px 12px');

				$('.' + wps_fb_data.prefix_dash + 'form input').css('padding', '6px 12px');
				$('.' + wps_fb_data.prefix_dash + 'form input').css('height', '32px');

				$(icon).css('font-size', parseInt(wps_fb_data.font_size) + 7 + 'px');
			}

			// Auto

			else {
				$('.' + wps_fb_data.prefix_dash + 'scroller li').css('height', '20px');
				$('.' + wps_fb_data.prefix_dash + 'scroller li').css('padding', '8px 0px');
				$('.' + wps_fb_data.prefix_dash + 'twitter-feed').css('height', '28px');
				$('.' + wps_fb_data.prefix_dash + 'recent-post').css('height', '34px');

				$('.' + wps_fb_data.prefix_dash + 'link-button').css('padding', '5px 10px');

				$('.' + wps_fb_data.prefix_dash + 'form input').css('padding', '5px 10px');
				$('.' + wps_fb_data.prefix_dash + 'form input').css('height', '30px');

				$(icon).css('font-size', parseInt(wps_fb_data.font_size) + 6 + 'px');
			}

		if (wps_fb_data.font_size != 'auto') {
			$(container).find('*')
				.not(show)
				.not(close)
				.not(icon)
				.not('input')
				.not('.' + wps_fb_data.prefix_dash + 'message')
				.css('font-size', wps_fb_data.font_size + 'px');
		}

		$(container).find('*')
			.not(show)
			.not(close)
			.not(icon)
			.not('input[type="text"]')
			.not('input[type="email"]')
			.not('.' + wps_fb_data.prefix_dash + 'message')
			.css('font-weight', wps_fb_data.font_weight);

		$(container).find('*')
			.not(show)
			.not(close)
			.not(icon)
			//.not('input')
			.css('font-family', wps_fb_data.font_family);

		// Position Style

		if (location == 'bottom' && wps_fb_data.position == 'absolute' && $(container).css('top') == 'auto') {
			var offset= $(document).height();
			$(container).css('top', offset);
			$(stub).css('top', offset);
		}

		$(container).css('position', wps_fb_data.position);
		$(stub).css('position', wps_fb_data.position);

		// Color Style

		$(show).css('background-color', wps_fb_data.color);
		$(text).css('color', wps_fb_data.text_color);
		$('.' + wps_fb_data.prefix_dash + 'message').css('color', wps_fb_data.text_color);
		$(container + ' li').css('color', wps_fb_data.text_color);

		$(container + ' a').css('color', wps_fb_data.link_text_color);
		$(link).css('color', wps_fb_data.link_text_color);

		$(show).css('color', wps_fb_data.icon_color);
		$(show).css('border', wps_fb_data.border_size + 'px solid ' + wps_fb_data.border_color);
		$(container).css('border-' + border_location, wps_fb_data.border_size + 'px solid ' + wps_fb_data.border_color);
		$(close).css('color', wps_fb_data.icon_color);
		//$(icon).css('color', wps_fb_data.text_color);

		$(link_button).css('background-color', wps_fb_data.link_button_color);
		$(nl_button).css('background-color', wps_fb_data.nl_button_color);
		$(nl_button).css('border', '1px solid ' + wps_fb_data.nl_button_color);
		$(nl_button).css('color', wps_fb_data.nl_text_color);
	}

	/**
	 * Adds a google font
	 *
	 * @access public
	 * @return void
	 */
	function addGoogleFont() {

		WebFont.load({
			google: {
			  families: [wps_fb_data.font_family]
			}
		});
	}

	/**
	 * Show firebar
	 *
	 * @access public
	 * @param mixed location
	 * @return void
	 */
	function wpsite_firebar_show(location) {

		addStyle(location);

		var container = '.' + wps_fb_data.prefix_dash + 'container-' + location;
		var stub = '.' + wps_fb_data.prefix_dash + 'stub-' + location;

		if(stub_showing) {
	      	if (wps_fb_data.animation == 'yes') {
	      		$(stub).slideUp('fast', function() {
			      	$(container).show(wps_fb_data.effect, {direction: "vertical"}, 500);

			      	if (wps_fb_data.move_body == 'yes' && location == 'top') {
			      		$('body').animate({paddingTop: $('.' + wps_fb_data.prefix_dash + 'container').outerHeight()}, 300);
			      	} else if (wps_fb_data.move_body == 'yes' && location == 'bottom') {
			      		$('body').animate({paddingBottom: $('.' + wps_fb_data.prefix_dash + 'container').outerHeight()}, 300);
			      	}
			  	});
	      	} else {
	      		$(stub).hide();
		      	$(container).show();

		      	if (wps_fb_data.move_body == 'yes') {
			    	$('body').attr('padding-' + location, $('.' + wps_fb_data.prefix_dash + 'container').outerHeight());
		      	}
	      	}
	    } else {
	    	if (wps_fb_data.animation == 'yes') {
	    		$(container).show(wps_fb_data.effect, {direction: "vertical"}, 500);

	    		if (wps_fb_data.move_body == 'yes' && location == 'top') {
		      		$('body').animate({paddingTop: $('.' + wps_fb_data.prefix_dash + 'container').outerHeight()}, 250);
		      	} else if (wps_fb_data.move_body == 'yes' && location == 'bottom') {
		      		$('body').animate({paddingBottom: $('.' + wps_fb_data.prefix_dash + 'container').outerHeight()}, 250);
		      	}
	    	} else {
		    	$(container).show();
				if (wps_fb_data.move_body == 'yes') {
			    	$('body').attr('padding-' + location, $('.' + wps_fb_data.prefix_dash + 'container').outerHeight());
		      	}
	    	}
	    }

		$(window).load(function() {
			if(stub_showing) {
		      	if (wps_fb_data.animation == 'yes') {
		      		$(stub).slideUp('fast', function() {
				      	$(container).show(wps_fb_data.effect, {direction: "vertical"}, 500);

				      	if (wps_fb_data.move_body == 'yes' && location == 'top') {
				      		$('body').animate({paddingTop: $('.' + wps_fb_data.prefix_dash + 'container').outerHeight()}, 300);
				      	} else if (wps_fb_data.move_body == 'yes' && location == 'bottom') {
				      		$('body').animate({paddingBottom: $('.' + wps_fb_data.prefix_dash + 'container').outerHeight()}, 300);
				      	}
				  	});
		      	} else {
		      		$(stub).hide();
			      	$(container).show();

			      	if (wps_fb_data.move_body == 'yes') {
				    	$('body').attr('padding-' + location, $('.' + wps_fb_data.prefix_dash + 'container').outerHeight());
			      	}
		      	}
		    } else {
		    	if (wps_fb_data.animation == 'yes') {
		    		$(container).show(wps_fb_data.effect, {direction: "vertical"}, 500);

		    		if (wps_fb_data.move_body == 'yes' && location == 'top') {
			      		$('body').animate({paddingTop: $('.' + wps_fb_data.prefix_dash + 'container').outerHeight()}, 250);
			      	} else if (wps_fb_data.move_body == 'yes' && location == 'bottom') {
			      		$('body').animate({paddingBottom: $('.' + wps_fb_data.prefix_dash + 'container').outerHeight()}, 250);
			      	}
		    	} else {
			    	$(container).show();
					if (wps_fb_data.move_body == 'yes') {
				    	$('body').attr('padding-' + location, $('.' + wps_fb_data.prefix_dash + 'container').outerHeight());
			      	}
		    	}
		    }
		});
	}

	/**
	 * Hide the firebar
	 *
	 * @access public
	 * @param mixed location
	 * @return void
	 */
	function wpsite_firebar_hide(location) {

		addStyle(location);

		var container = '.' + wps_fb_data.prefix_dash + 'container-' + location;
		var stub = '.' + wps_fb_data.prefix_dash + 'stub-' + location;

		if (wps_fb_data.animation == 'yes') {
			$(container).slideUp('fast', function() {

				if ( !wps_fb_data.close_button ) {
					$(stub).show(wps_fb_data.effect, {direction: "vertical"}, 500);
					stub_showing = true;
				}

			});

			if (location == 'top') {
	      		$('body').animate({paddingTop: "0px"}, 250);
	      	} else {
	      		$('body').animate({paddingBottom: "0px"}, 250);
	      	}

		} else {
			$(container).hide();

			if ( !wps_fb_data.close_button ) {
				$(stub).show();
				stub_showing = true;
			}

			if( $(window).width() > 1024 ) {
				$('body').attr("padding-" + location, "0px");
			}
		}
	}

	/**
	 * Get all text nodes and wrap in p tags
	 *
	 * @access public
	 * @param mixed node
	 * @param mixed includeWhitespaceNodes
	 * @return void
	 */
	function wpsite_getTextNodesIn(node, includeWhitespaceNodes) {
	    var textNodes = [], whitespace = /^\s*$/;

	    function wpsite_getTextNodes(node) {
	        if (node.nodeType == 3) {
	            if (includeWhitespaceNodes || !whitespace.test(node.nodeValue)) {
	                textNodes.push(node);
	            }
	        } else {
	            for (var i = 0, len = node.childNodes.length; i < len; ++i) {
	                wpsite_getTextNodes(node.childNodes[i]);
	            }
	        }
	    }

	    wpsite_getTextNodes(node);
	    return textNodes;
	}
});